*******************************************************************************
* Filename: terminal.s
* Author:  James D. Purdy
* Description: ASCII terminal program rewritten from an old HP48
* source file I ran across.
* 	
* Revision: 1.1
* Revision date: 1/25/2000
* Stack diagram:  N/A
* 	( --> )
*******************************************************************************
INCLUDE Header.h 

::

 ( Uppercase Characters )
  { # 41    # 42    # 43    # 44    # 45    # 46
    # 47    # 48    # 49    # 27
    # 4A    # 4B    # 4C    #0      #0      #0
    # 4D    # 4E    # 4F    # 50    #08
    # 51    # 52    # 53    # 54    # 55
    # 56    # 57    # 58    # 59    # 5A
    # 0     # 37    # 38    # 39    # 2A
    # 0     # 34    # 35    # 36    # 2D
    # 0     # 31    # 32    # 33    # 2B
    # 0     # 30    # 2E    # 20    # 0d }


( Lowercase Characters )
  {  # 61    # 62    # 63    # 64    # 65    # 66
     # 67    # 68    # 69    # 27
     # 6A    # 6B    # 6C    #0      #0      #0
     # 6D    # 6E    # 6F    # 70    #08
     # 71    # 72    # 73    # 74    # 75    
     # 76    # 77    # 78    # 79    # 7A    
     # 0     # 37    # 38    # 39    # 2A
     # 0     # 34    # 35    # 36    # 2D
     # 0     # 31    # 32    # 33    # 2B
     # 0     # 30    # 2E    # 20    # 0a   }

' ::  (  format subr )
 3GETLAM LEN$ 31 #>
 IT :: 6GETLAM EVAL NULL$ 3PUTLAM ;
 3GETLAM 2GETLAM &$ DUP 3PUTLAM
 "\0d" ONE POS$ 1PUTLAM ::

  1GETLAM DUP 0 #> SWAP 32 #< AND
  case ::
          3GETLAM DUP 1GETLAM #1+ OVERLEN$ SUB$SWAP    ( split string at CR )
          1GETLAM 1_#1-SUB$
          DUPLEN$ 33 SWAP #- Blank$ &$ 3PUTLAM 2PUTLAM ;

 3GETLAM LEN$ 32 #>
 case ::
           3GETLAM DUP 1 32 SUB$ 3PUTLAM    ( break off 32 chars )
           33 OVERLEN$ SUB$ 2PUTLAM   ;

    NULL$ 2PUTLAM
    ;
  ;

' ::   (  display subr )
  ZERO 45 3GETLAM CHR_UndScore >T$ $>grob XYGROBDISP
 ;

' :: (  scroll subr )

  ZEROZERO HARDBUFF 0 7 131 64 SUBGROB XYGROBDISP   ( move the screen up)
  ZERO 45 33 Blank$ $>grob XYGROBDISP               ( blank the last line )

;

' ::   ( send subr )
 DUP 52 #<
 ITE
  ::
    4GETLAM ITE 10GETLAM  9GETLAM   ( UC or LC )
    SWAP NTHCOMPDROP #>CHR CHR>$   ( get character from list )
    xXMIT NOT IT DROP
   ;
  ::
    DROP 4GETLAM NOT 4PUTLAM  ( change case )
   ;
;

  TRUE NULL$ DUP ONE

 ' NULLLAM ( 10 upper case characters )
 ' NULLLAM ( 9 lower case characters )
 ' NULLLAM ( 8 format recieved subr )
 ' NULLLAM ( 7 Display subr )
 ' NULLLAM ( 6 Scroll subr )
 ' NULLLAM ( 5 Send subr )
 ' NULLLAM ( 4 Uppercase? flag )
 ' NULLLAM ( 3 Display String  )
 ' NULLLAM ( 2 Received data string )
 ' NULLLAM ( 1 POS$ of CR )
 TEN DOBIND

 xOPENIO
 RECLAIMDISP CLEARMENU  FLUSHKEYS
 #0 "dTerm v1.1" $>grob Grob>Menu

 BEGIN  ( main loop )

  GETTOUCH IT :: 5GETLAM  EVAL ;  ( get a key and transmit it )

  BEGIN
   DOBUFLEN %0=            ( while there are chars in buffer )
   ITE :: DROPFALSE ;       ( get them )
       :: DUP %0 %> ITE TRUE DROPFALSE ;
  WHILE
   DOSRECV %0= ITE DROP   ( get chars and append to the received string )
   :: 2GETLAM SWAP&$
      2PUTLAM ;
  REPEAT
  8GETLAM EVAL     ( format the data )
  7GETLAM EVAL     ( display the data )
 ATTN?             ( stop when cancel is pressed )
UNTIL
  xCLOSEIO
  RECLAIMDISP
 ; 








 



